// ukljuciti potrebne .h fajlove
#include <iostream>
#include <iomanip>
#include <sstream>
#include <fstream>
using namespace std;

int tests_passed = 0;
int points = 0;

void addPoints(int test_number) {
	switch (test_number) {
	case 1:
		points += 2;
		break;
	case 2:
		points += 2;
		break;
	case 3:
		points += 2;
		break;
	case 4:
		points += 2;
		break;
	case 5:
		points += 2;
		break;
	case 6:
		points += 1;
		break;
	case 7:
		points += 1;
		break;
	case 8:
		points += 3;
		break;
	case 9:
		points += 3;
		break;
	case 10:
		points += 3;
		break;
	case 11:
		points += 3;
		break;
	case 12:
		points += 4;
		break;
	case 13:
		points += 4;
		break;
	case 14:
		points += 3;
		break;
	}
}

// Funkcija koja poredi Vas izlaz sa ocekivanim izlazom za odgovarajuci test primer
void checkOutput(const string& log_filename, int test_number) {

	ifstream correct_output("correct_log_" + to_string(test_number) + ".txt");
	stringstream ss_correct;
	ss_correct << correct_output.rdbuf(); correct_output.close();
	string correct_file_system = ss_correct.str();

	ifstream student_output(log_filename);
	stringstream ss_student;
	ss_student << student_output.rdbuf(); student_output.close();
	string student_file_system = ss_student.str();

	if (student_file_system != "" && student_file_system == correct_file_system) {
		cout << "Test " + to_string(test_number) + ": PASSED" << endl;
		addPoints(test_number);
		tests_passed++;
	}
	else {
		cout << "Test " + to_string(test_number) + ": FAILED" << endl;
	}

}

void test(int test_number) {

	fstream file("student_log_" + to_string(test_number) + ".txt", ios::out);

	Player p1("Dominic", "Thiem", "AUS", 9125);
	Player p2("Matteo", "Berrettini", "ITA", 3345);

	RegularPoint rp1(p1, p2);
	BorderPoint bp1(p2, p1, BorderPoint::State::OUT);
	NetPoint np1(p1, p2);

	TennisMatch* match = nullptr;
	TennisTournament* tournament = nullptr;
	TennisMatch* match1 = nullptr, * match2 = nullptr, * match3 = nullptr;
	Point* p = nullptr;

	switch (test_number) {
	case 1:
		file << "Igrac 1: " << p1 << endl;
		file << "Igrac 2: " << p2 << endl;
		break;
	case 2:
		p1.updateMatchCount(10);
		p1.updateMatchWinsCount(5);
		p2.updateMatchCount(6);
		p2.updateMatchWinsCount(1);
		file << "Igrac 1 sa evidentiranim mecevima: " << p1.getMatchCount() << ":" << p1.getMatchWinsCount() << endl;
		file << "Igrac 2 sa evidentiranim mecevima: " <<  p2.getMatchCount() << ":" << p2.getMatchWinsCount() << endl;
		break;
	case 3:
		file << "Vrsta prvog poena odigranog izmedju igraca: " << rp1.getKind() << endl;
		break;
	case 4:
		file << "Poen odigran izmedju igraca:" << endl << rp1.getPointMaker() << endl << rp1.getPointReceiver() << endl;
		break;
	case 5:
		rp1.setPointWinner(&p1);
		file << "Pobednik poena: " << *rp1.getPointWinner()<< endl;
		rp1.setPointWinner(&p2);
		file << "Promenjeni pobednik poena: " << *rp1.getPointWinner() << endl;
		break;
	case 6:
		match = new TennisMatch();
		match->readMatch("input_1.txt");
		p = (*match)[2];
		file << p->getKind() << ": " << p->getPointMaker() << "vs: " << p->getPointReceiver() <<  endl;
		delete match;
		break;
	case 7:
		match = new TennisMatch();
		match->readMatch("input_1.txt");
		try {
			p = (*match)[6];
			file << p->getKind() << ": " << p->getPointMaker() << "vs: " << p->getPointReceiver() << endl;
		}
		catch (exception&) {
			file << "Greska!" << endl;
		}
		delete match;
		break;
	case 8:
		match = new TennisMatch();
		match->readMatch("input_2.txt");
		try {
			file << *match->predictWinner() << endl;
		}
		catch (exception&) {
			file << "Greska!" << endl;
		}
		delete match;
		break;
	case 9:
		match = new TennisMatch();
		match->readMatch("input_2.txt");
		try {
			file << *match->decideWinner() << endl;
		}
		catch (exception&) {
			file << "Greska!" << endl;
		}
		delete match;
		break;
	case 10:
		match = new TennisMatch();
		match->readMatch("input_1.txt");
		file << "Predvidja se da ce pobednik meca biti: " << *match->predictWinner() << endl;
		delete match;
		break;
	case 11:
		match = new TennisMatch();
		match->readMatch("input_3.txt");
		file << "Predvidja se da ce pobednik meca biti: " << *match->predictWinner() << endl;
		delete match;
		break;
	case 12:
		match = new TennisMatch();
		match->readMatch("input_4.txt");
		file << "Predvidja se da ce pobednik meca biti: " << *match->predictWinner() << endl;
		delete match;
		break;
	case 13:
		match = new TennisMatch();
		match->readMatch("input_5.txt");
		file << "Predvidja se da ce pobednik meca biti: " << *match->predictWinner() << endl;
		delete match;
		break;
	case 14:
		match = new TennisMatch();
		match->readMatch("input_6.txt");
		file << "Pobednik meca je: " << *match->decideWinner() << endl;
		delete match;
		break;
	}

	file.close();

	checkOutput("student_log_" + to_string(test_number) + ".txt", test_number);
}

int main() {

	// Izmeniti elemente niza u zavisnosti od testova koje zelite da pokrenete!
	int active_tests[] = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14};
	int number_of_tests = sizeof(active_tests) / sizeof(int);

	cout << "============================================" << endl;
	cout << "TESTING TENNIS MATCHES" << endl << endl;
	cout << "Executing tests: ";
	for (int i = 0; i < number_of_tests; i++) cout << active_tests[i] << (i < number_of_tests - 1 ? ", " : "");
	cout << endl;

	for (int i = 0; i < number_of_tests; i++) test(active_tests[i]);

	cout << "============================================" << endl;
	cout << "Tests passed count: " << tests_passed << endl;
	cout << "Points: " << points << endl;

	return 0;
}